<template>
    <div class="row justify-center q-pa-lg">
        <div class="col-5">
            <q-card flat bordered>
                <q-item>
                    <q-item-section avatar>
                        <q-avatar v-if="worker != null" size="64px">
                            <img :src="worker.principal.image" :alt="Avatar" style="width: 64px; height: 64px;" class="bg-base">
                        </q-avatar>
                        <q-skeleton v-else type="QAvatar"/>
                    </q-item-section>

                    <q-item-section>
                        <q-item-label v-if="worker != null" class="text-h5">
                            {{ worker.principal.name }}
                        </q-item-label>
                        <q-skeleton v-else type="text"/>
                        <q-item-label v-if="worker != null" caption>
                            <router-link :to="`/subcontractor/${worker.subContractor.id}`">{{
                                    worker.subContractor.name
                                                                                           }}
                            </router-link>
                        </q-item-label>
                        <q-skeleton v-else type="text"/>
                        <q-item-label v-if="worker != null" caption>
                            {{ worker.principal.id }}
                        </q-item-label>
                        <q-skeleton v-else type="text"/>
                    </q-item-section>
                    <q-item-section v-if="worker.tag.macAddress" top side>
                        <q-badge>
                            {{ worker.tag.macAddress }}
                        </q-badge>
                    </q-item-section>
                </q-item>
                <q-item v-if="worker.principal.trade.length > 0">
                    <div class="wrap row">
                        <q-chip v-for="t in worker.principal.trade" :key="t">
                            <q-avatar color="red" text-color="white"> {{ t.Take() }}</q-avatar>
                            {{ t }}
                        </q-chip>
                    </div>
                </q-item>
                <q-separator/>
                <q-item style="min-height: 300px;" class="column justify-center">
                    <MetaData v-if="worker != null" :meta="worker.principal.data" class="full-width"/>
                    <q-skeleton v-else height="300px" class="full-width"/>
                </q-item>
                <q-separator/>
                <q-card-actions align="around">
                    <q-btn v-if="worker != null"
                           flat label="edit" icon="edit" color="primary"
                           :to="`/worker/edit/${worker.principal.id}`"
                    />
                    <q-skeleton v-else type="QBtn"/>
                    <q-btn v-if="worker != null"
                           outline icon="delete" label="delete" color="negative"
                           @click="$emit('delete')"
                    />
                    <q-skeleton v-else type="QBtn"/>
                </q-card-actions>
            </q-card>

        </div>
    </div>
</template>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {GenerateAvatar} from "src/classLibrary/AvatarGenerator";
import {WorkerResponse} from "src/classLibrary/APIModels/core/workerResponse";
import MetaData from "components/Entities/MetaData.vue";

@Component({
    components: {MetaData}
})
export default class WorkerFullCard extends Vue {
    @Prop() worker!: WorkerResponse;

    get Avatar() {
        return GenerateAvatar(this.worker?.principal.name ?? "A")
    }
}
</script>

<style lang='scss' scoped>

</style>
